import 'package:fis_measure/interfaces/process/items/terms.dart';

import '../primitives/straightline.dart';
import 'calculator.dart';

class HeartRateCal extends Calculator<StraightLine, double> {
  HeartRateCal(StraightLine ref) : super(ref);

  @override
  void calculate() {
    if (ref.feature == null) return;

    final feature = ref.feature! as StraightLineHeartRateFeature;
    print("心跳循环数：${feature.heartCycle}");
    //修改心跳周期
    //feature.setHeartRate(2);

    final heartCycle = feature.heartCycle;
    final viewport = feature.hostVisualArea!.viewport!;
    final p1 = feature.startPoint;
    final p2 = feature.endPoint;
    final pp1 = viewport.convert(p1);
    final pp2 = viewport.convert(p2);

    final time = (pp2.x - pp1.x).abs();
    final hr = (heartCycle / time) * 60;
    for (var output in ref.meta.outputs) {
      if (output.name == MeasureTerms.HeartRate) {
        feature.updateFloatValue(output, hr, output.unit);
      } else if (output.name == "Heart Cycle") {
        feature.updateFloatValue(output, heartCycle.toDouble(), output.unit);
      } else if (output.name == MeasureTerms.Timespan) {
        feature.updateFloatValue(output, time, output.unit);
      }
    }
  }
}
